---
title: FileSystemWritableFileStream
slug: Web/API/FileSystemWritableFileStream
tags:
  - File
  - File System Access API
  - FileSystemWritableFileStream
  - Interface
  - stream
  - write file
---
<div>{{draft}}{{securecontext_header}}{{DefaultAPISidebar("File System Access API")}}</div>

<p class="summary">The <strong><code>FileSystemWritableFileStream</code></strong> interface of the {{domxref('File System Access API')}} is a {{domxref('WritableStream')}} object with additional convenience methods, which operates on a single file on disk. The interface is accessed through the {{domxref('FileSystemFileHandle.createWritable()')}} method.</p>

<h2 id="Properties">Properties</h2>

<p><em>Inherits properties from its parent, {{DOMxRef("WritableStream")}}.</em></p>

<h2 id="Methods">Methods</h2>

<p><em>Inherits methods from its parent, {{DOMxRef("WritableStream")}}.</em></p>

<dl>
 <dt>{{domxref('FileSystemWritableFileStream.write')}}</dt>
 <dd>Writes content into the file the method is called on, at the current file cursor offset.</dd>
 <dt>{{domxref('FileSystemWritableFileStream.seek')}}</dt>
 <dd>Updates the current file cursor offset to the position (in bytes) specified.</dd>
 <dt>{{domxref('FileSystemWritableFileStream.truncate')}}</dt>
 <dd>Resizes the file associated with the stream to be the specified size in bytes.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>This asynchronous function opens the 'Save File' picker, which returns a {{domxref('FileSystemFileHandle')}} once a file is selected. From which a writable stream is then created using the {{domxref('FileSystemFileHandle.createWritable()')}} method.</p>

<p>A user defined {{domxref('Blob')}} is then written to the stream which is subsequently closed.</p>

<pre class="brush: js notranslate">async function saveFile() {

  // create a new handle
  const newHandle = await window.showSaveFilePicker();

  // create a FileSystemWritableFileStream to write to
  const writableStream = await newHandle.createWritable();

  // write our file
  await writableStream.write(imgBlob);

  // close the file and write the contents to disk.
  await writableStream.close();
}
</pre>

<p>The following show different examples of options that can be passed into the <code>write()</code> method.</p>

<pre class="brush: js notranslate">// just pass in the data (no options)
writableStream.write(data)

// writes the data to the stream from the determined position
writableStream.write({ type: "write", position: position, data: data })

// updates the current file cursor offset to the position specified
writableStream.write({ type: "seek", position: position })

// resizes the file to be size bytes long
writableStream.write({ type: "truncate", size: size })
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('File System Access API','#api-filesystemwritablefilestream','FileSystemWritableFileStream')}}</td>
   <td>{{Spec2('File System Access API')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.FileSystemWritableFileStream")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/docs/Web/API/File_System_Access_API">File System Access API</a></li>
 <li><a href="https://web.dev/file-system-access/">The File System Access API: simplifying access to local files</a></li>
</ul>
